package my.test;

import java.io.*;
import java.util.*;

import javax.xml.parsers.*;

import org.apache.log4j.Logger;
import org.w3c.dom.*;
import org.xml.sax.SAXException;

public class LoadConfig {
	Logger							logger		= Logger.getLogger(this.getClass().getName());
	public static HashMap<String, String>	configMap	= new HashMap<String, String>();

	

	
	String	configPath;

	public boolean loadConfiguration() {

		try {
			DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();

			factory.setNamespaceAware(true);
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.parse(new File(configPath));

			NodeList nodes = document.getElementsByTagName("element");

			String parameter, value;

			for (int i = 0; i < nodes.getLength(); i++) {

				org.w3c.dom.Element e = (Element) nodes.item(i);

				NodeList nl = e.getElementsByTagName("parameter");
				org.w3c.dom.Element content = (Element) nl.item(0);
				parameter = content.getTextContent();

				nl = e.getElementsByTagName("value");
				content = (Element) nl.item(0);
				value = content.getTextContent();
				logger.info("Adding configuration parameter:" + parameter + ",value:" + value);
				configMap.put(parameter, value);
			}
		} catch (SAXException e) {
			e.printStackTrace();
			return false;

		} catch (ParserConfigurationException e) {
			// e.printStackTrace();
			logger.info(e.getMessage());
			logger.info("Cannot load configuration.");
			return false;
		} catch (IOException e) {
			logger.info(e.getMessage());
			logger.info( "Cannot load configuration.");
			return false;
		}

		logger.info("Loaded configuration successfully.");
		return true;
	}

	public String getConfig(String key) {
		String value = null;
		value = configMap.get(key);
		return value;
	}

	public boolean setConfigFilePath(String configPath) {

		this.configPath = configPath;
		return true;
	}
}

